/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCDATASection.h"

#include "CDATASection.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSCDATASectionTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCDATASectionConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCDATASectionTable = { 2, 1, true, JSCDATASectionTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSCDATASectionConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCDATASectionConstructorTable = { 1, 0, false, JSCDATASectionConstructorTableValues, 0 };
const ClassInfo JSCDATASectionConstructor::s_info = { "CDATASectionConstructor", &Base::s_info, &JSCDATASectionConstructorTable, 0, CREATE_METHOD_TABLE(JSCDATASectionConstructor) };

JSCDATASectionConstructor::JSCDATASectionConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSCDATASectionConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSCDATASectionPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSCDATASectionConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSCDATASectionConstructor, JSDOMWrapper>(exec, JSCDATASectionConstructorTable, jsCast<JSCDATASectionConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSCDATASectionPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCDATASectionPrototypeTable = { 1, 0, false, JSCDATASectionPrototypeTableValues, 0 };
const ClassInfo JSCDATASectionPrototype::s_info = { "CDATASectionPrototype", &Base::s_info, &JSCDATASectionPrototypeTable, 0, CREATE_METHOD_TABLE(JSCDATASectionPrototype) };

JSObject* JSCDATASectionPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCDATASection>(vm, globalObject);
}

const ClassInfo JSCDATASection::s_info = { "CDATASection", &Base::s_info, &JSCDATASectionTable, 0 , CREATE_METHOD_TABLE(JSCDATASection) };

JSCDATASection::JSCDATASection(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<CDATASection> impl)
    : JSText(structure, globalObject, impl)
{
}

void JSCDATASection::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSCDATASection::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCDATASectionPrototype::create(vm, globalObject, JSCDATASectionPrototype::createStructure(vm, globalObject, JSTextPrototype::self(vm, globalObject)));
}

bool JSCDATASection::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSCDATASection* thisObject = jsCast<JSCDATASection*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSCDATASection, Base>(exec, JSCDATASectionTable, thisObject, propertyName, slot);
}

EncodedJSValue jsCDATASectionConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSCDATASection* domObject = jsDynamicCast<JSCDATASection*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSCDATASection::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSCDATASection::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCDATASectionConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}
