/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSComment.h"

#include "Comment.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSCommentTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCommentConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCommentTable = { 2, 1, true, JSCommentTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSCommentConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCommentConstructorTable = { 1, 0, false, JSCommentConstructorTableValues, 0 };
EncodedJSValue JSC_HOST_CALL JSCommentConstructor::constructJSComment(ExecState* exec)
{
    JSCommentConstructor* castedThis = jsCast<JSCommentConstructor*>(exec->callee());
    const String& data(argumentOrNull(exec, 0).isEmpty() ? String() : argumentOrNull(exec, 0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());
    ScriptExecutionContext* context = castedThis->scriptExecutionContext();
    if (!context)
        return throwVMError(exec, createReferenceError(exec, "Comment constructor associated document is unavailable"));
    RefPtr<Comment> object = Comment::create(*context, data);
    return JSValue::encode(asObject(toJS(exec, castedThis->globalObject(), object.get())));
}

const ClassInfo JSCommentConstructor::s_info = { "CommentConstructor", &Base::s_info, &JSCommentConstructorTable, 0, CREATE_METHOD_TABLE(JSCommentConstructor) };

JSCommentConstructor::JSCommentConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSCommentConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSCommentPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSCommentConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSCommentConstructor, JSDOMWrapper>(exec, JSCommentConstructorTable, jsCast<JSCommentConstructor*>(object), propertyName, slot);
}

ConstructType JSCommentConstructor::getConstructData(JSCell*, ConstructData& constructData)
{
    constructData.native.function = constructJSComment;
    return ConstructTypeHost;
}

/* Hash table for prototype */

static const HashTableValue JSCommentPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCommentPrototypeTable = { 1, 0, false, JSCommentPrototypeTableValues, 0 };
const ClassInfo JSCommentPrototype::s_info = { "CommentPrototype", &Base::s_info, &JSCommentPrototypeTable, 0, CREATE_METHOD_TABLE(JSCommentPrototype) };

JSObject* JSCommentPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSComment>(vm, globalObject);
}

const ClassInfo JSComment::s_info = { "Comment", &Base::s_info, &JSCommentTable, 0 , CREATE_METHOD_TABLE(JSComment) };

JSComment::JSComment(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<Comment> impl)
    : JSCharacterData(structure, globalObject, impl)
{
}

void JSComment::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSComment::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCommentPrototype::create(vm, globalObject, JSCommentPrototype::createStructure(vm, globalObject, JSCharacterDataPrototype::self(vm, globalObject)));
}

bool JSComment::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSComment* thisObject = jsCast<JSComment*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSComment, Base>(exec, JSCommentTable, thisObject, propertyName, slot);
}

EncodedJSValue jsCommentConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSComment* domObject = jsDynamicCast<JSComment*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSComment::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSComment::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCommentConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}
