/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SVG)

#include "JSSVGElementInstanceList.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSSVGElementInstance.h"
#include "SVGElementInstance.h"
#include "SVGElementInstanceList.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSSVGElementInstanceListTableValues[] =
{
    { "length", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSVGElementInstanceListLength), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSVGElementInstanceListConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSVGElementInstanceListTable = { 5, 3, true, JSSVGElementInstanceListTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSSVGElementInstanceListConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSVGElementInstanceListConstructorTable = { 1, 0, false, JSSVGElementInstanceListConstructorTableValues, 0 };
const ClassInfo JSSVGElementInstanceListConstructor::s_info = { "SVGElementInstanceListConstructor", &Base::s_info, &JSSVGElementInstanceListConstructorTable, 0, CREATE_METHOD_TABLE(JSSVGElementInstanceListConstructor) };

JSSVGElementInstanceListConstructor::JSSVGElementInstanceListConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSSVGElementInstanceListConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSSVGElementInstanceListPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSSVGElementInstanceListConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGElementInstanceListConstructor, JSDOMWrapper>(exec, JSSVGElementInstanceListConstructorTable, jsCast<JSSVGElementInstanceListConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSSVGElementInstanceListPrototypeTableValues[] =
{
    { "item", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsSVGElementInstanceListPrototypeFunctionItem), (intptr_t) (0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSVGElementInstanceListPrototypeTable = { 2, 1, false, JSSVGElementInstanceListPrototypeTableValues, 0 };
const ClassInfo JSSVGElementInstanceListPrototype::s_info = { "SVGElementInstanceListPrototype", &Base::s_info, &JSSVGElementInstanceListPrototypeTable, 0, CREATE_METHOD_TABLE(JSSVGElementInstanceListPrototype) };

JSObject* JSSVGElementInstanceListPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSSVGElementInstanceList>(vm, globalObject);
}

bool JSSVGElementInstanceListPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSVGElementInstanceListPrototype* thisObject = jsCast<JSSVGElementInstanceListPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSSVGElementInstanceListPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSSVGElementInstanceList::s_info = { "SVGElementInstanceList", &Base::s_info, &JSSVGElementInstanceListTable, 0 , CREATE_METHOD_TABLE(JSSVGElementInstanceList) };

JSSVGElementInstanceList::JSSVGElementInstanceList(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SVGElementInstanceList> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSSVGElementInstanceList::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSSVGElementInstanceList::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSSVGElementInstanceListPrototype::create(vm, globalObject, JSSVGElementInstanceListPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSSVGElementInstanceList::destroy(JSC::JSCell* cell)
{
    JSSVGElementInstanceList* thisObject = static_cast<JSSVGElementInstanceList*>(cell);
    thisObject->JSSVGElementInstanceList::~JSSVGElementInstanceList();
}

JSSVGElementInstanceList::~JSSVGElementInstanceList()
{
    releaseImplIfNotNull();
}

bool JSSVGElementInstanceList::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSVGElementInstanceList* thisObject = jsCast<JSSVGElementInstanceList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSSVGElementInstanceList, Base>(exec, JSSVGElementInstanceListTable, thisObject, propertyName, slot);
}

EncodedJSValue jsSVGElementInstanceListLength(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSVGElementInstanceList* castedThis = jsDynamicCast<JSSVGElementInstanceList*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SVGElementInstanceList& impl = castedThis->impl();
    JSValue result = jsNumber(impl.length());
    return JSValue::encode(result);
}


EncodedJSValue jsSVGElementInstanceListConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSSVGElementInstanceList* domObject = jsDynamicCast<JSSVGElementInstanceList*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSSVGElementInstanceList::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSSVGElementInstanceList::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSVGElementInstanceListConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsSVGElementInstanceListPrototypeFunctionItem(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSSVGElementInstanceList* castedThis = jsDynamicCast<JSSVGElementInstanceList*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSSVGElementInstanceList::info());
    SVGElementInstanceList& impl = castedThis->impl();
    unsigned index(toUInt32(exec, exec->argument(0), NormalConversion));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.item(index)));
    return JSValue::encode(result);
}

bool JSSVGElementInstanceListOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSSVGElementInstanceListOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSSVGElementInstanceList* jsSVGElementInstanceList = jsCast<JSSVGElementInstanceList*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSVGElementInstanceList->impl(), jsSVGElementInstanceList);
    jsSVGElementInstanceList->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7SVGElementInstanceList@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore22SVGElementInstanceListE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, SVGElementInstanceList* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSSVGElementInstanceList>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7SVGElementInstanceList@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore22SVGElementInstanceListE[2];
#if COMPILER(CLANG)
    // If this fails SVGElementInstanceList does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(SVGElementInstanceList), SVGElementInstanceList_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // SVGElementInstanceList has subclasses. If SVGElementInstanceList has subclasses that get passed
    // to toJS() we currently require SVGElementInstanceList you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<SVGElementInstanceList>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSSVGElementInstanceList>(exec, globalObject, impl);
}

SVGElementInstanceList* toSVGElementInstanceList(JSC::JSValue value)
{
    return value.inherits(JSSVGElementInstanceList::info()) ? &jsCast<JSSVGElementInstanceList*>(value)->impl() : 0;
}

}

#endif // ENABLE(SVG)
